var map;
var mgr;
var map_canvas;
var sidebar;
var sidebar_content;

var data = [
	{name:"Návštěvník Pražského hradu",lat:50.090352,lng:14.398994},
	{name:"Vlak",lat:49.189773,lng:16.610687},
	{name:"Horolezec",lat:50.555816,lng:15.176901},
	{name:"Student na FAVce",lat:49.725316,lng:13.350853},
	{name:"Tramvaj č.4",lat:49.734643,lng:13.370338},
	{name:"Letadlo",lat:50.106271,lng:14.260789},
	{name:"Autobus",lat:50.089509,lng:14.441487}
];

var markers = [];
var inputs = [];

var maplok = {
	init: function() {
		if (GBrowserIsCompatible()) {
			map_canvas = document.getElementById("map_canvas");
			sidebar = document.getElementById("sidebar");
			sidebar_content = document.getElementById("sidebar_content");

			var height=document.documentElement.clientHeight;
			var width=document.documentElement.clientWidth;
			map_canvas.style.height = height + "px";
			map_canvas.style.width = (width - 250) + "px";
			sidebar.style.height = height + "px";

			map = new GMap2(map_canvas);
			map.setCenter(new GLatLng(49.930008,15.369873), 7);
			map.setMapType(G_NORMAL_MAP);
			map.setUIToDefault();
			
			map.addControl(new GOverviewMapControl());
			
			mgr = new MarkerManager(map, {trackMarkers: true });

			if (window.attachEvent) {
				window.attachEvent("onresize", maplok.resize);
			} else {
				window.addEventListener("resize", maplok.resize, false);
			}
			window.setTimeout(maplok.createObjects, 0);
		}
	},
	destroy: function() {
		GUnload();
		markers = [];
		inputs = [];
	},
	resize: function() {
		var height=document.documentElement.clientHeight;
		var width=document.documentElement.clientWidth;

		map_canvas.style.height = height + "px";
		map_canvas.style.width = (width - 250) + "px";
		sidebar.style.height = height + "px";

		map.checkResize();
		map.setCenter(map.getCenter());
	},
	createObjects: function() {
		for(var i=0; i < data.length; i++) {
		  var item = data[i];

			var point = new GLatLng(item.lat, item.lng);
		  var marker = new GMarker(point, {title: item.name});
		  var clickFn = (function() { //reseni na joining closures
				var id = i;
				return function() { maplok.showDialog(id); }
      })();
		  GEvent.addListener(marker, "click", clickFn);

			mgr.addMarker(marker, 3);
			maplok.createSidebarItem(i, item);

			markers.push(marker);
		}
		document.getElementById("sidebar_header_group").appendChild(document.createTextNode(markers.length + " objekt\u016F"));
	},
	createSidebarItem: function(id, item) {
		var input = document.createElement("input");
		input.type = "checkbox";
		GEvent.addDomListener(input, "click", function() {
			maplok.setVisible(id, input.checked);
		});
		input.checked = true;
		input.name = "list";

		var label = document.createElement("label");
		label.appendChild(input);

		label.appendChild(document.createTextNode(item.name));
		
		var a = document.createElement("a");
		a.href = "javascript:void(0)";
		GEvent.addDomListener(a, "click", function() {
			maplok.showDialog(id);
			return true;
		});
		
		a.appendChild(document.createTextNode("ukázat"));
		var div = document.createElement("div");
		div.setAttribute("class", "item");
		div.setAttribute("className", "item");
		div.appendChild(label);
		
		div.appendChild(document.createTextNode(" ("));
		div.appendChild(a);
		div.appendChild(document.createTextNode(")"));

		sidebar_content.appendChild(div);
		inputs.push(input);
	},
	setVisible: function(id, checked) {
		inputs[id].checked = checked;
		if (checked) {
			document.getElementById("sidebar_header_group_checkbox").checked = true;
			markers[id].show();
		} else {
			markers[id].hide();

			var uncheckAll = true;
			for(var i=0; i < inputs.length; i++) {
					if (inputs[i].checked) {
						uncheckAll = false;
						break;
					}
			}
			if (uncheckAll) {
				document.getElementById("sidebar_header_group_checkbox").checked = false;
			}
		}
	},
	viewAll: function(checked) {
		document.getElementById("sidebar_header_group_checkbox").checked = checked;
		for(var i=0; i < markers.length; i++) {
			inputs[i].checked = checked;
			if (checked) {
				markers[i].show();
			} else {
				markers[i].hide();
			}
		}
	},
	showDialog: function(id) {
		var html = "<strong>" + data[id].name + "</strong>";
		if (map.getZoom() < 9) map.setZoom(9);
		map.panTo(markers[id].getLatLng());
		map.openInfoWindowHtml(markers[id].getLatLng(), html);
	}
};